﻿using System;
using System.Windows;
using System.Windows.Media.Animation;

namespace SilverlightScroller
{
    public static class AnimationExtensions
    {
        // this method borrowed from:  http://www.robertjantuit.nl/index.php/2008/08/13/animateto-extension-methods-in-silverlight-2/
        public static void AnimateDoubleTo(this UIElement element, int milliseconds, string propertyPath, double value, EventHandler completed)
        {
            // Create a new storyboard
            var sb = new Storyboard();

            // Create a double animation
            var da = new DoubleAnimation();
            da.Duration = new TimeSpan(0, 0, 0, 0, milliseconds);

            // Set target property and target
            Storyboard.SetTargetProperty(da, new PropertyPath(propertyPath));
            Storyboard.SetTarget(da, element);
            da.To = value;

            // Add the doubleanimation to the storyboard
            sb.Children.Add(da);

            // Add the storyboard to the Rootvisual of the application
            ((FrameworkElement) Application.Current.RootVisual).Resources.Add(Guid.NewGuid().ToString(), sb);

            // Begin the animation
            sb.Begin();

            if (completed != null)
                sb.Completed += completed;
        }
    }
}
