﻿using System;
using System.Windows;
using System.Windows.Controls;

namespace SilverlightScroller
{
    //  most of this class was borrowed from:  
    //    http://www.robertjantuit.nl/index.php/2008/09/13/storyboard-animation-for-the-scrollviewer-animationhelpercontrol/
    //    There is a great explanation there.
   public class AnimationHelperControl : Control
   {
        public AnimationHelperControl()
        {
            Visibility = Visibility.Collapsed;
        }

        public double AnimationValue
        {
            get { return (double)GetValue(AnimationValueProperty); }
            set
            {
                SetValue(AnimationValueProperty, value);
                AnimationValueChanged(value);
            }
        }
        
        public static readonly DependencyProperty AnimationValueProperty =
            DependencyProperty.Register("AnimationValue", typeof(double), typeof(AnimationHelperControl), 
                new PropertyMetadata((sender, e) =>
                    {
                        if (e.OldValue != e.NewValue)
                        {
                            (sender as AnimationHelperControl).AnimationValue = (double) e.NewValue;
                        }
                    }));

        public event EventHandler<AnimationEventArgs> AnimationValueChange;

        private void AnimationValueChanged(double newValue)
        {
            if (AnimationValueChange != null)
                AnimationValueChange(this, new AnimationEventArgs() { Value = newValue });
        }
    }

   public class AnimationEventArgs: EventArgs
   {
       public double Value { get; set; }
   }
}
