﻿using System.Linq;
using System.Windows;
using System.Windows.Controls;
using Microsoft.Windows.Controls;

namespace SilverlightScroller
{
    public class ScrollerListBox : ListBox
    {
        public ScrollViewer ScrollHost { get; internal set; }
        public double ItemWidth { get; internal set; }
        
        public ScrollerListBox()  { }
        
        protected override void PrepareContainerForItemOverride(DependencyObject element, object item) 
        {
            base.PrepareContainerForItemOverride(element, item); 
            
            if (ScrollHost == null)
            {
                ScrollHost = this.GetLogicalChildrenBreadthFirst().OfType<ScrollViewer>().FirstOrDefault();
                ItemWidth = ScrollHost.GetLogicalChildrenBreadthFirst().OfType<WrapPanel>().FirstOrDefault().ItemWidth;
            }    
        }
    }
}


